---
title: MediaTrackConstraints.displaySurface
slug: Web/API/MediaTrackConstraints/displaySurface
tags:
  - API
  - Capture
  - Constraints
  - Media
  - Media Capture and Streams
  - Media Capture and Streams API
  - MediaTrackConstraints
  - Property
  - Reference
  - Screen Capture
  - Screen Capture API
  - Sharing
  - Video
  - display
  - displaySurface
  - screen
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The {{domxref("MediaTrackConstraints")}} dictionary's <strong><code>displaySurface</code></strong> property is a {{domxref("ConstrainDOMString")}} describing the requested or mandatory constraints placed upon the value of the {{domxref("MediaTrackSettings.displaySurface", "displaySurface")}} constrainable property.</span> This is used to specify the type or types of display surfaces which {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}} will let the user select among for sharing purposes.</p>

<p>If needed, you can determine whether or not this constraint is supported by checking the value of {{domxref("MediaTrackSupportedConstraints.displaySurface")}} as returned by a call to {{domxref("MediaDevices.getSupportedConstraints()")}}. However, typically this is unnecessary since browsers will ignore any constraints they're unfamiliar with.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>constraintsObject</em> = { displaySurface: <em>constraint</em> };

<em>constraintsObject</em>.displaySurface = <em>constraint</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("ConstrainDOMString")}} which specifies the type of display surface that's being captured. This value <em>does not</em> affect the list of display sources in the browser's user interface.</p>

<p>See {{SectionOnPage("/en-US/docs/Web/API/Media_Streams_API/Constraints", "How constraints are defined")}} for an explanation of how to define constraints.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>You can check the setting selected by the user agent after the display media has been created by {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}} by calling {{domxref("MediaStreamTrack.getSettings", "getSettings()")}} on the display media's video {{domxref("MediaStreamTrack")}}, then checking the value of  the returned {{domxref("MediaTrackSettings")}} object's {{domxref("MediaTrackSettings.displaySurface", "displaySurface")}} object.</p>

<p>For example, if your app needs to know that the surface being shared is a monitor or application—meaning that there's possibly a non-content backdrop—it can use code similar to this:</p>

<pre class="brush: js">let mayHaveBackdropFlag = false;
let displaySurface = displayStream.getVideoTracks()[0].getSettings().displaySurface;

if (displaySurface === "monitor" || displaySurface ==="application") {
  mayHaveBackdropFlag = true;
}
</pre>

<p>Following this code, <code>mayHaveBackdrop</code>  is <code>true</code> if the display surface contained in the stream is of type <code>monitor</code> or <code>application</code>; either of these <em>may</em> have non-content backdrop areas. Later code can use this flag to determine whether or not to perform special processing, such as to remove or replace the backdrop, or to "cut" the individual display areas out of the received frames of video.</p>

<h2 id="Example">Examples</h2>

<p>Here are some example constraints objects for <code>getDisplayMedia()</code> that make use of the <code>displaySurface</code> property. In addition, see {{SectionOnPage("/en-US/docs/Web/API/Media_Streams_API/Constraints", "Example: Constraint exerciser")}} for a complete example showing how constraints are used.</p>

<p>TBD</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Screen Capture', '#dom-mediatrackconstraintset-displaysurface', 'MediaTrackConstraints.displaySurface') }}</td>
   <td>{{ Spec2('Screen Capture API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaTrackConstraints.displaySurface")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API">Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture">Using the Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
 <li>{{domxref("MediaDevices.getSupportedConstraints()")}}</li>
 <li>{{domxref("MediaTrackSupportedConstraints")}}</li>
</ul>
